"""
Sample code for Huiwen Jia and Siqian Shen, "Benders Cut Classification via Support Vector Machines for Solving Two-stage Stochastic Programs", INFORMS Jounal on Optimization, 2020.

@author: hwjia@umich.edu
"""
import sys
from gurobipy import *
import numpy as np


#datapath = 'cap41.txt'

def reading_capdata(datapath):
    f = open(datapath)
    line = f.readline()
    nW=int(line.split(" ")[1])
    nF=int(line.split(" ")[2])
      
    
    # read warehouse    
    Warehouse = tuplelist()
    setup = {}
    capacity = {}
    Pair = tuplelist()
    cost = tupledict()
    for i in range(1,nW+1):
        ware = ''.join(("W",str(i)))
        Warehouse = Warehouse + [ware]
        line = f.readline()
        setup[ware] = int(line.split(" ")[2].split('.')[0])
        capacity[ware] = int(line.split(" ")[1])    
    
    mu=[]    
    Factory = tuplelist()
    lostsalecost = {}
    for j in range(1,nF+1):
        line = f.readline()
        demand = int(line.split(' ')[1])
        mu.append(demand)
        fac = ''.join(("F",str(j)))
        Factory = Factory + [fac]
        cost_str=[]
        for count in range(int(nW/7)):
            line = f.readline()
            cost_str= cost_str + [float(line.split(' ')[i]) for i in range(1,8)]
        line = f.readline()
        cost_str= cost_str + [float(line.split(' ')[i]) for i in range(1,nW%7 + 1)]
        if len(cost_str) != nW:
            print('Data error 1')
        for i in range(1,nW+1):
            ware = ''.join(("W",str(i)))
            Pair = Pair + [(ware,fac)]
            cost[(ware,fac)] = cost_str[i-1]/demand
        lostsalecost[fac] = max(cost_str)/demand
    f.close()
    
    mu=np.array(mu)
    
    return(nW, 
           nF,  
           Warehouse, 
           setup, 
           capacity, 
           Pair, 
           cost, 
           Factory, 
           lostsalecost, 
           mu) 