"""
Sample code for Huiwen Jia and Siqian Shen, "Benders Cut Classification via Support Vector Machines for Solving Two-stage Stochastic Programs", INFORMS Jounal on Optimization, 2020.

@author: hwjia@umich.edu
"""
import random
import numpy as np
from numpy.linalg import cholesky
import math
from gurobipy import *


def sce_ge_normal(mu, scale_sigma, nsce, nF, Factory):
    Sigma = np.diag(scale_sigma*mu)

    Scenario = []
    probability = {}
    for s in range(1,nsce+1) :
        sce= ''.join(["S",str(s)])
        Scenario.append(sce)
        probability[sce] = 1/nsce
    Scenario = tuplelist(Scenario)
    
    
    R = cholesky(Sigma)
    demandpre = np.dot(np.random.randn(nsce, nF), R) + mu
    Demand = {}
    i=0
    for s in Scenario:
        i+=1
        j=0
        for d in Factory:
            Demand[s,d] = round(demandpre[i-1, j])
            j += 1 
    return (Scenario, 
            probability, 
            Demand)